--- old/usr/src/uts/common/fs/zfs/spa_errlog.c	2013-05-16 14:21:06.270872195 -0600
+++ new/usr/src/uts/common/fs/zfs/spa_errlog.c	2013-05-16 14:21:06.279495334 -0600
@@ -183,8 +183,10 @@
 
 		if (copyout(&zb, (char *)addr +
 		    (*count - 1) * sizeof (zbookmark_t),
-		    sizeof (zbookmark_t)) != 0)
+		    sizeof (zbookmark_t)) != 0) {
+			zap_cursor_fini(&zc);
 			return (SET_ERROR(EFAULT));
+		}
 
 		*count -= 1;
 	}
